/*****************************************************************************
	AmyEdit - A GTKMM LaTeX Editor
	Copyright (C) 2004-2005 Rob Page
	email:  page <dot> rob <at> gmail <dot> com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *****************************************************************************/

#ifndef _AMYEDIT_HH
#define _AMYEDIT_HH

#include <gtkmm/window.h>
#include <gtkmm/paned.h>
#include <gtkmm/actiongroup.h>
#include <gtkmm/tooltips.h>
#include <gtkmm/uimanager.h>

#include "EditTabs.hh"
#include "PrefStruct.hh"
#include "StatusBar.hh"

class AmyEdit : public Gtk::Window
{  
	public:
		static AmyEdit* instance();
		static void goodnight();

		void open(Glib::ustring filename);
		void open_recent(int filenumber);
		void set_output_text(Glib::ustring text);
		void pop_up_output();
		void add_recent_file(Glib::ustring filename);

	private:
		static AmyEdit* smInstance;
		AmyEdit();
		~AmyEdit();

	public:
		EditTabs *edittabs;

	private:
		Gtk::TextView output;
		Gtk::VPaned paneview;
		StatusBar statusbar;

		bool on_delete_event(GdkEventAny* event);

		void on_new();
		void on_open();
		void on_save();
		void on_save_as();
		void on_save_all();
		void on_close();
		void on_export();
		void on_save_as_template();
		void on_quit();

		void on_find();

		void on_preview();

		void on_spellcheck();
		void on_word_count();

		void on_preferences();

		void on_about();

		void on_file_open(bool file);

		Glib::RefPtr<Gtk::UIManager> uiman;
		Glib::RefPtr<Gtk::ActionGroup> need_file_ag;
		Glib::RefPtr<Gtk::ActionGroup> recent_files_ag;
		Gtk::UIManager::ui_merge_id recent_files_id;

		void recent_files_update(bool unmerge_old_id=true);
};

#endif
