/*****************************************************************************
	AmyEdit - A GTKMM LaTeX Editor
	Copyright (C) 2004-2005 Rob Page
	email:  page <dot> rob <at> gmail <dot> com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *****************************************************************************/

#ifndef _NEWDIALOG_HH
#define _NEWDIALOG_HH

#include <gtkmm/dialog.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/notebook.h>

#include "TextListViewListBox.hh"

class NewDialog : public Gtk::Dialog
{  

	public:
		NewDialog();
		~NewDialog();
		Glib::ustring getDoc();

	private:
		Gtk::RadioButton a4paper, a5paper;
		Gtk::RadioButton article, report;
		Gtk::CheckButton parindent, doublespacing;

		Glib::ustring getDocString();
		void on_save_template();
		void populate_listbox();

		Gtk::Notebook tabs;
		TextListViewListBox listbox;

};
#endif
