/*****************************************************************************
	AmyEdit - A GTKMM LaTeX Editor
	Copyright (C) 2004-2005 Rob Page
	email:  page <dot> rob <at> gmail <dot> com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *****************************************************************************/


#ifndef _SPELLDIALOG_HH
#define _SPELLDIALOG_HH

#include <gtksourceviewmm/sourcebuffer.h>
#include <gtkmm/dialog.h>
#include <gtkmm/entry.h>
#include <aspell.h>
#include <map>

#include "TextListViewListBox.hh"
#include "Plugin.hh"

class SpellDialog : public Gtk::Dialog, public Plugin
{
	public:

		/* Plugin Interface */
		static int engage();
		static void init();
		static void deinit();

	private:
		SpellDialog();
		~SpellDialog();

		static AspellConfig *get_config();

		void on_preferences_update();
	
		Gtk::SourceView* view;
		Glib::RefPtr<Gtk::SourceBuffer> buffer;
		Gtk::Entry misslabel;
		Gtk::Entry replaceentry;
		TextListViewListBox listbox;

		void setCheckArea(Glib::RefPtr<Gtk::TextMark> areastart, 
		                  Glib::RefPtr<Gtk::TextMark> areaend);
		AspellToken getNextMiss();

		Glib::ustring ret;

		int checkDocument();
		bool changeWord(AspellToken miss, Gtk::TextIter wordstart);

		void on_replace();
		void on_replaceall();
		void on_skip();
		void on_skipall();
		void on_add();
		void on_selection_changed();

		void get_suggestions();

		AspellSpeller *speller;  
		AspellDocumentChecker *checker;  
		std::map<Glib::ustring, Glib::ustring> skiprep;

		Glib::ustring current_string;
		int delta_area;
};

#endif // _SPELLDIALOG_HH
